/**
 * La classe Cluster2 represente un cluster de matrices
 * @author Aude Liefooghe
 */


#ifndef Cluster2_h
#define Cluster2_h
#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <list>
#include <math.h>
#include <functional>
#include <algorithm>
#include "Matrices.h"

using namespace std;

class Cluster2
{

public:
  /**
  Constructeur de la classe
  Construit un cluster vide
  */
  Cluster2();
  /**
  @return vrai si le taux de faux positifs
  */
  ///Liste d'entiers
  typedef vector < short > vi;
  /// Le nombre de matrice du cluster
  short nbMat;
  /// Liste des matrices du cluster
  vi listMat;
  /// Le num�os de matrice du noyau du cluster
  short noyau;
  /// La matrice moyenne des matrices du cluster
  Matrice * moyenne;
  /// L'ensemble des matrices de travail
  static Matrices * matrices;
  /**
  @param m L'ensemble des matrices de travail
  */
  static void setMatrices(Matrices* m)
  {
    matrices = m;
  }
  /**
  @param n Le num�os de matrice du noyau du cluster
  */
  void setNoyau( short n );
  /**
  @return Le nombre de matrice du cluster
  */
  short getNbMat();
  /**
  @return Le numéros de matrice du noyau
  */
  short getNoyau();
  /**
  @return La matrice noyau
  */
  Matrice * getNoyau2();
  /**
  @return le num�o de la i�e matrice du cluster
  */
  short getMat( short i );
  /**
  @param m La matrice moyenne des matrices du cluster
  */
  void setMoyenne( Matrice * m);
  /**
  @return m La matrice moyenne des matrices du cluster
  */
  Matrice * getMoyenne();
  /**
  Ajoute une nouvelle matrice au cluster
  */
  void addMat( short m );
};
#endif




