#include "Clusterisation.h"


using namespace std;


Clusterisation::Clusterisation()
{
}

vector<Cluster2> Clusterisation::make_cluster(float **m,int dimension, float p1,Matrices* mats)
{
  int coordx,coordy;
  float minimo;
  int heightOfTree;
  VectorCluster v(dimension);
  VectorNodes n(dimension);
  int dim=dimension;
  float **constant;
  int node_info;
  vector<Cluster2> vClusters;
  constant=new float*[dimension];
  for(int i=0;i<dimension;i++)
    constant[i]=new float[dimension];
  for(int i=0;i<dimension;i++)
    for (int j=0;j<dimension;j++)
      constant[i][j]=m[i][j];
  v.generate_vector(dimension);
  n.generate_vector(dimension);
  do
  {
    minimo=look_for_min(v,m,dimension,coordx,coordy);
    dimension--;
    v.generate_cluster(coordx,coordy);
    node_info=v.set_node_info((coordx<coordy)?coordx:coordy);
    n.generate_branch(coordx,coordy,node_info);
    recalculate_matrix(m,dimension,v,constant,coordx);
  }
  while(dimension!=1);
  heightOfTree=n.heightOfTree();
  vClusters=n.print_cluster(heightOfTree,dim,constant, p1, mats);
  return vClusters;
}





int Clusterisation::recalculate_matrix(float **m,int dimension,VectorCluster v,float **constant,int x)
{
  for(int i=0;i<dimension;i++)
  {
    int ipos = v.at(i).get_value();
    Cluster c = v.at(x);
    int jpos = v.at(x).get_value();
    m[ipos][jpos]=v.calculate_distance(i,x,constant);
    m[jpos][ipos]=m[ipos][jpos];
  }
}




float Clusterisation::look_for_min(VectorCluster v,float **m,int dimension,int &coordx,int &coordy)
{
  int i,j;
  coordx=0;
  coordy=1;
  int ipos = v.at(coordx).get_value();
  int jpos = v.at(coordy).get_value();
  float minimo=m[ipos][jpos];
  for (i=0;i<dimension;i++)
    for(j=i+1;j<dimension;j++)
    {
      ipos = v.at(i).get_value();
      jpos = v.at(j).get_value();
      if(m[ipos][jpos]<minimo)
      {
        minimo=m[ipos][jpos];
        coordx=i;
        coordy=j;
      }
      if(m[jpos][ipos]<minimo)
      {
        minimo=m[jpos][ipos];
        coordx=j;
        coordy=i;
      }
    }
  return minimo;
}

















