/**
 * La classe Decoupage represente une decoupage de la structure StrucMatrices en sous-tableaux
 * @author Aude Liefooghe
 */

#include <iostream>
#include <vector>
#include <math.h>
using namespace std;


class Decoupage{
      /// L'ensemble des positions de dpart des sous-tableaux
        vector<int> pos;
        /// La somme du nombre d'acces a chaque sous-tableau de la structure
        double nbAcces;
	int mem;

public :
  /**
  Constructeur de la classe
  Construit un decoupage vide de position avec un nombre d'acces correspondant a un sous-tableau 
  de position de dpart 0 ou bien un nombre d'acces de 9999 c'est  dire un decoupage de la structure impossible
  */
        Decoupage(double nbA);
/**
@return L'ensemble des positions de dpart des sous-tableaux
*/
        vector<int> getPos();
/**
@return La position de dpart du sous-tableau i
@param i L'indice du sous-tableau
*/
        int getPos(int i);
        /**
@return La somme du nombre d'acces a chaque sous-tableau de la structure
*/
        double getNbAcces();
/**
Ajoute une position de dpart donc un sous-tableau au decoupage et ajoute le nombre d'acces correspondant
a ce nouveau sous-tableau
*/
        void addPos(int p, long double d) ;
void toString() ;
 void setMo(int mo);
};
