using namespace std;

#include "Matrice.h"
#include <algorithm>

float Matrice::getPoids(int i )
{
  if (i<0) return 0;
  if (i>=taille) return 1;
  return poids[i];
}

void Matrice::setDec(int d)
{
  dec = d;
}

int Matrice::getGLB(int i)
{
  return GLB[i]; //+1;
}

int Matrice::getMinGLB()
{
  return * min_element( GLB, GLB+taille+1 );
}

int Matrice::getDebTest()
{
  return debTest;
}

int Matrice::getDec()
{
  return dec;
}

Matrice::Matrice( double *mat[4],  int t,  string n, int prec,int psc, int pVal, float pGC)
{
  pValeur = pVal;
  precision = prec;
  nom = n;
  nom2 = n;
  taille=t;
  if (nom2[0]=='V') nom2.replace(1, 1,"S");
  if (nom[0]=='M') jasp = 0;
  else jasp = 1;
  int j, k;
  for ( int k = 0; k < 4; k++ )
  {
    matDist[k] = NULL;
    matDistInt[k] = NULL;
    matInt[k] = NULL;
    matFreq[k] = NULL;
    matScore[k] = NULL;
  }

  for ( k = 0; k < 4; k++ )
  {
    matDist[k] = new float[taille];
    matDistInt[k] = new int[taille];
    matInt[k] = new int[taille];
    matFreq[k] = new float[taille];
    matScore[k] = new float[taille];
  }
  for ( j = 0; j < taille; j++ )
  {
    * ( matDist[0] + j ) =  mat[0][j] ;
    * ( matDist[1] + j ) =  mat[1][j] ;
    * ( matDist[2] + j ) =  mat[2][j] ;
    * ( matDist[3] + j ) =  mat[3][j] ;

    * ( matFreq[0] + j ) =  0;
    * ( matFreq[1] + j ) =  0 ;
    * ( matFreq[2] + j ) =  0;
    * ( matFreq[3] + j ) =  0;

    * ( matDistInt[0] + j ) = (int) roundl((* ( matDist[0] + j ) )*precision);
    * ( matDistInt[1] + j ) = (int) roundl(( * ( matDist[1] + j ) )*precision);
    * ( matDistInt[2] + j ) = (int) roundl(( * ( matDist[2] + j ) )*precision);
    * ( matDistInt[3] + j ) = (int) roundl(( * ( matDist[3] + j ) )*precision);
  }
  setPourGC(pGC);
  calcDistrib();
  RempliPoids();
  calcDistrib();
  constGLB();

}

Matrice::Matrice( string c, string n, int prec, int psc, int pVal, float pGC)
{
  pValeur = pVal;
  precision = prec;
  chemin = c;
  nom = n;
  nom2 = n;

  if (nom2[0]=='V') nom2.replace(1, 1,"S");
  if (nom[0]=='M') jasp = 0;
  else jasp = 1;
  int j, k;
  for ( int k = 0; k < 4; k++ )
  {
    matDist[k] = NULL;
    matDistInt[k] = NULL;
    matInt[k] = NULL;
    matFreq[k] = NULL;
    matScore[k] = NULL;
  }
  lectMat();
  som = 0;
  // JS: we compute maximal sum over columns in order to avoid a division error when computing the weights
  float som2[taille];
  for ( j = 0; j < taille; j++ )
  {
    som2[j]=0;
    for ( k = 0; k < 4; k++ )
    {
      som2[j] += * ( matDist[k]+j);
    }
    if (som2[j] > som) { som = som2[j]; } 
  }
  
  //cerr << "Maximal sum for a column " << som << endl;
  
  /* AUDE: old version, the sum was computed using the first column
  for ( k = 0; k < 4; k++ )
  {
    som += * ( matDist[k] );
  }
  //ecrMat();
  float som2[taille];
  for ( j = 0; j < taille; j++ )
  {
    som2[j]=0;
    for ( k = 0; k < 4; k++ )
    {
      som2[j] += * ( matDist[k]+j);
    }
    */
  
  // we compute the matrix coefficients with corrections using pseudocounts
  for ( j = 0; j < taille; j++ )
  {
    float s = som - som2[j]+1;
    * ( matFreq[0] + j ) = ( * ( matDist[0] + j ) + ( (float) s*psc/4 ) ) / ( som + psc );
    * ( matFreq[1] + j ) = ( * ( matDist[1] + j ) + ( (float) s*psc/4 ) ) / ( som + psc );
    * ( matFreq[2] + j ) = ( * ( matDist[2] + j ) + ( (float) s*psc/4 ) ) / ( som + psc );
    * ( matFreq[3] + j ) = ( * ( matDist[3] + j ) + ( (float) s*psc/4 ) ) / ( som + psc );

    * ( matDist[0] + j ) = log(* ( matFreq[0] + j ) );
    * ( matDist[1] + j ) = log( * ( matFreq[1] + j ) );
    * ( matDist[2] + j ) = log( * ( matFreq[2] + j ) );
    * ( matDist[3] + j ) = log( * ( matFreq[3] + j ) );

    * ( matDistInt[0] + j ) = (int) roundl((* ( matDist[0] + j ) )*precision);
    * ( matDistInt[1] + j ) = (int) roundl(( * ( matDist[1] + j ) )*precision);
    * ( matDistInt[2] + j ) = (int) roundl(( * ( matDist[2] + j ) )*precision);
    * ( matDistInt[3] + j ) = (int) roundl(( * ( matDist[3] + j ) )*precision);
  }
  setPourGC(pGC);

  if ( som < 2 )
  {
     cout << "Warning : matrix " << nom << " seems to be a weight matrix and not a frequency matrix." << endl;
  }
  calcDistrib();
  RempliPoids();
  calcDistrib();
  constGLB();
}

int Matrice::calcMax (int deb)
{
  int s = 0;
  for(int j = deb; j<taille;  j++)
  {
    s += getMaxInt(j);
  }
  return s;
}
int Matrice::getSeuil(){
return seuil;
}
void Matrice::constGLB ()
{
  GLB = new int [taille+1];
  for(int i = 0; i<taille+1; i++)
  {
    GLB[i]=seuil-calcMax(i);
  }
}

float Matrice::getMatDist( int i, int j )
{
  return * ( matDist[i] + j );
}

int Matrice::getMatDistInt( int i, int j )
{
  return * ( matDistInt[i] + j );
}

bool Matrice::testJasp()
{
  return jasp;
}

float Matrice::getMatScore( int i, int j )
{
  return * ( matScore[i] + j );
}

int Matrice::getMatInt( int i, int j )
{
  return * ( matInt[i] + j ); 
}

float Matrice::getMatFreq( int i, int j )
{
  return * ( matFreq[i] + j );
}

float Matrice::getMaxDist( int j )
{
  list < float > l1;
  for ( short i = 0; i < 4; i++ )
  {
    l1.insert( l1.begin(), matDist[i] [j] );
  }
  return * max_element( l1.begin(), l1.end() );

}

int Matrice::getMaxDistInt( int j )
{
  list < int > l1;
  for ( short i = 0; i < 4; i++ )
  {
    l1.insert( l1.begin(), matDistInt[i] [j] );
  }
  return * max_element( l1.begin(), l1.end() );

}

int Matrice::getMaxInt( int j )
{
if (j>taille-1 || j<0) return 0;
  list < int > l1;
  for ( short i = 0; i < 4; i++ )
  {
    l1.insert( l1.begin(), matInt[i] [j] );
  }
  return * max_element( l1.begin(), l1.end() );
}

float Matrice::getMaxFreq( int j )
{
  list < float > l1;
  for ( short i = 0; i < 4; i++ )
  {
    l1.insert( l1.begin(), matFreq[i] [j] );
  }
  return * max_element( l1.begin(), l1.end() );
}

int Matrice::getMaxFreqInd( int j )
{
  float tab[4];
  for ( short i = 0; i < 4; i++ )
  {
    tab[i] = matFreq[i][j];
  }
  return max_element( tab, tab+4 ) - tab;
}

float Matrice::getMaxScore( int j )
{
  list < float > l1;
  for ( short i = 0; i < 4; i++ )
  {
    l1.insert( l1.begin(), matScore[i] [j] );
  }
  return * max_element( l1.begin(), l1.end() );
}

float Matrice::getMoyScore( int j )
{
  float m = 0;
  for ( short i = 0; i < 4; i++ )
  {
    m+=matScore[i][j];
  }
  return (float) ((float) m/4);
}

float Matrice::getMoyDist( int j )
{
  float m = 0;
  for ( short i = 0; i < 4; i++ )
  {
    m+=matDist[i][j];
  }
  return (float) ((float) m)/4;
}

float Matrice::getMinDist( int j )
{
  list < float > l1;
  for ( short i = 0; i < 4; i++ )
  {
    l1.insert( l1.begin(), matDist[i] [j] );
  }
  return * min_element( l1.begin(), l1.end() );
}

int Matrice::getMinDistInt( int j )
{
  list < int > l1;
  for ( short i = 0; i < 4; i++ )
  {
    l1.insert( l1.begin(), matDistInt[i] [j] );
  }
  return * min_element( l1.begin(), l1.end() );
}

int Matrice::getMinInt( int j )
{
  list < int > l1;
  for ( short i = 0; i < 4; i++ )
  {
    l1.insert( l1.begin(), matInt[i] [j] );
  }
  return * min_element( l1.begin(), l1.end() );
}

string Matrice::getChemin()
{
  return chemin;
}

string Matrice::getNom()
{
  return nom;
}

string Matrice::getFam()
{
  return fam;
}

string Matrice::getNom2()
{
  return nom2;
}

int Matrice::getTaille()
{
  return taille;
}

void Matrice::toStringPoids()
{
  for (int j = 0; j < taille+1; j++ )
  {
    cout << poids[j] << "\t";
  }
  cout << endl;
}

void Matrice::toStringMatScore()
{
  int j;
  cout << chemin << endl << "Name : " << nom << endl << "A\tC\tG\tT" << endl;
  for ( j = 0; j < taille; j++ )
  {
    cout << * ( matScore[0] + j ) << "\t" << * ( matScore[1] + j ) << "\t" << * ( matScore[2] + j ) << "\t" << * ( matScore[3] + j ) << endl;
  }
}

void Matrice::toStringMatFreq()
{
  int j;
  cout << chemin << endl << "Name : " << nom  << " Freq  A\tC\tG\tT" << endl;
  for ( j = 0; j < taille; j++ )
  {
    cout << * ( matFreq[0] + j ) << "\t" << * ( matFreq[1] + j ) << "\t" << * ( matFreq[2] + j ) << "\t" << * ( matFreq[3] + j ) << endl;
  }
}

void Matrice::toStringMatDistInt()
{
  int j;
  cout << chemin << endl << "Name : " << nom  << "length : " << taille << " Score  A\tC\tG\tT" << endl;
  for(int i =0; i<4; i++)
  {
    for ( j = 0; j < taille; j++ )
    {
      cout << * ( matDistInt[i] + j ) << "\t" ;
    }
    cout << endl;
  }
}

void Matrice::toStringMatInt()
{
  int j;
  cout << chemin << endl << "Name : " << nom  << "length : " << taille << " Score  A\tC\tG\tT" << endl;
  for(int i =0; i<4; i++)
  {
    for ( j = 0; j < taille; j++ )
    {
      cout << * ( matInt[i] + j ) << "\t" ;
    }
    cout << endl ;
  }
      for ( j = 0; j < taille; j++ )
    {
      cout << GLB[j] << "\t" ;
    }
    cout << endl ;
  cout << seuil << endl;
}
void Matrice::toStringMatDist()
{
  int j;
  for ( j = 0; j < taille; j++ )
  {
    cout << * ( matDist[0] + j ) << "\t" << * ( matDist[1] + j ) << "\t" << * ( matDist[2] + j ) << "\t" << * ( matDist[3] + j ) << endl;
  }
}

void Matrice::toStringDistrib()
{
  for (int k = -min; k>0; k--)
  {
    cout << -k << " : " << neg[0][k] << endl;
  }
  for (int k = 0; k<=maxi; k++)
  {
    cout << k << " : " << pos[0][k] << endl;
  }
}

void Matrice::toStringDistribCumul()
{
  for (int k = -min; k>=0; k--)
  {
    cout << -k << " : " << neg[1][k] << endl;
  }

  for (int k = 0; k<=maxi; k++)
  {
    cout << k << " : " << pos[1][k] << endl;
  }

}

Matrice::~Matrice( void )
{
  for ( int k = 0; k < 4; k++ )
  {
    if ( matDist[k] != NULL ) delete[] matDist[k];
    if ( matFreq[k] != NULL ) delete[] matFreq[k];
    if ( matScore[k] != NULL ) delete[] matScore[k];
  }
}

void Matrice::setPourGC(float pGC)
{
  if (pourGC != pGC)
  {
    pourGC = pGC;
    calcParam();
  }
}

float Matrice::getPourGC()
{
  return pourGC;
}
void Matrice::calcParam()
{
  int j;
  float pGC = (float) pourGC / 2;
  float pAT =  (float) ( 1 - pourGC ) / 2;
  float donneesAT=0, donneesGC=0;
  for ( j = 0; j < taille; j++ )
  {
    * ( matScore[0] + j ) = (* ( matDist[0] + j ) - log (pAT));
    * ( matScore[1] + j ) = (* ( matDist[1] + j ) - log (pGC));
    * ( matScore[2] + j ) = (* ( matDist[2] + j ) - log (pGC));
    * ( matScore[3] + j ) = (* ( matDist[3] + j ) - log (pAT));

    * ( matInt[0] + j ) = (int) (roundl(* ( matScore[0] + j )*precision ));
    * ( matInt[1] + j ) = (int) (roundl(* ( matScore[1] + j )*precision ));
    * ( matInt[2] + j ) = (int) (roundl(* ( matScore[2] + j )*precision ));
    * ( matInt[3] + j ) = (int) (roundl(* ( matScore[3] + j )*precision ));
  }
  for ( j = 0; j < taille; j++ )
  {
    donneesAT += * ( matScore[0] + j ) + * ( matScore[3] + j );
    donneesGC += * ( matScore[1] + j ) + * ( matScore[2] + j );
  }
  moy = (pAT * donneesAT + pGC * donneesGC);
}

int Matrice::getPrecision()
{
  return precision;
}

int Matrice::calcSeuilMax(long double pval)
{
  for (int k = maxi -1; k>=0; k--)
  {
    if ((pos[1][k]) > pval) return ((k+1));
  }
  for (int k = 1; k<=-min; k++)
  {
    if ((neg[1][k]) > pval) return ((-k+1));
  }
}

long double Matrice::calcPval(int seuil)
{
  int s = seuil;
  if (s >=0)
  {
    if (s>maxi) return 0;
    else return pos[1][s]+(1-neg[1][-min]);
  }
  else
  {
    if (s<min) return 1;
    else return neg[1][-s]+(1-neg[1][-min]);
  }
}

void Matrice::lectMat()
{
  ifstream fe( ( chemin + nom ).data(), ios_base::in );
  if ( !fe )
  {
    cerr << "The file " << nom << " is missing" << endl;
    exit( -1 );
  }
  if ( fe.eof() )
  {
    cerr << "The file " << nom << " is empty" << endl;
    exit( -1 );
  }
  string buf;
  int i = 0, j = 0, k;
  int bolPrem = 1;
  while ( !fe.eof() )
  {
    getline( fe, buf, '\n' );
    if ( bolPrem )
    {

      string::size_type debut = buf.find_first_not_of( " \t" );
      string::size_type pos = buf.find_first_of( " \t", debut );
      nomV = buf.substr( debut, pos - ( debut) );//cout << "nomV : " << nomV << endl;
      debut = buf.find_first_not_of( " \t", pos );
      pos = buf.find_first_of( " \t", debut );
      fam = buf.substr( debut );

      getline( fe, buf, '\n' );
      string old_buf = buf;
      debut = buf.find_first_not_of( " \t" );
      while ( debut != string::npos )
      {
        // Recherche la fin du mot suivant :
        string::size_type pos = buf.find_first_of( " \t", debut );
        // Affiche le mot :
        debut = buf.find_first_not_of( " \t", pos );
        i++;
      }
      bolPrem = 0;
      taille = i;
      //cout << taille << ",";
      i = 0;
      for ( k = 0; k < 4; k++ )
      {
        matDist[k] = new float[taille];
        matDistInt[k] = new int[taille];
        matInt[k] = new int[taille];
        matFreq[k] = new float[taille];
        matScore[k] = new float[taille];
      }
      buf = old_buf;
    }
    string::size_type debut = buf.find_first_not_of( " \t" );
    // Decompose la chaine en mots :
    while ( debut != string::npos )
    {
      // Recherche la fin du mot suivant :
      string::size_type pos = buf.find_first_of( " \t", debut );
      // Affiche le mot :
      if ( pos != string::npos )
      {
        if ( buf[debut + 1] == '|' )
        {
          * ( matDist[i] + j ) = atof( buf.substr( debut + 2, pos - ( debut + 2 ) ).data() );
          //cout << *(matDist[i]+j) << endl;
        }
        else
        {
          * ( matDist[i] + j ) = atof( buf.substr( debut, pos - debut ).data() );
          //cout << *(matDist[i]+j) << endl;
        }
      }
      else
      {
        * ( matDist[i] + j ) = atof( buf.substr( debut ).data() );
        //cout << *(matDist[i]+j) << endl;
      }
      debut = buf.find_first_not_of( " \t", pos );
      j++;
    }
    i++;
    j = 0;
  }
  fe.close();
}

void Matrice::ecrMat()
{
  for ( int k = 0; k < 4; k++ )
  {
    matAlign[k] = new float[taille];
  }
  for ( int j = 0; j < taille; j++ )
  {
    * ( matAlign[0] + j ) = (* ( matDist[0] + j )) *100; //cout << * ( matDist[0] + j ) << endl;
    * ( matAlign[1] + j ) = (* ( matDist[1] + j )) *100; //cout << * ( matDist[1] + j ) << endl;
    * ( matAlign[2] + j ) = (* ( matDist[2] + j )) *100; //cout << * ( matDist[2] + j ) << endl;
    * ( matAlign[3] + j ) = (* ( matDist[3] + j )) *100; //cout << * ( matDist[3] + j ) << endl;
  }
  ofstream fs( ("Matrices/"+nom2).data(), ios_base::out );
  if ( !fs.is_open())
  {
    cerr << nom2 << " is not creates" << endl;
    exit( -1 );
  }
  int cpt[taille], cpt2=0;
  while(cpt2<(som*100))
  {
    for(int i=0 ; i<taille; i++)
    {
      if(matAlign[0][i] >= 0.5)
      {
        fs << "a";
        matAlign[0][i]--;
      }
      else
      {
        if(matAlign[1][i] >= 0.5)
        {
          fs << "c";
          matAlign[1][i]--;
        }
        else
        {
          if(matAlign[2][i] >= 0.5)
          {
            fs << "g";
            matAlign[2][i]--;
          }
          else
          {
            if(matAlign[3][i] >= 0.5)
            {
              fs << "t";
              matAlign[3][i]--;
            }
            else
            {
              cpt[i]=1;
              fs << "_";
            }
          }
        }
      }
    }
    fs << endl;
    cpt2++;
  }
  fs.close();
  string s = "../weblogo/seqlogo -c -n -Y -t \"" + nom2 + "\" -F PDF -f Matrices/" + nom2 + " > Matrices/"+ nom2 + ".pdf";//-c option couleur
  int res = system(s.c_str());
}

void Matrice::calcDistrib()
{
  float pGC = pourGC/2;
  float pAT = (1-pourGC)/2;
  float pourc;
  short tour = 0, tour2 = 1, ech;
  int l[4], t;
  float o;
  long double somCumul;
  min =0;
  maxi = 0;
  float cpt;
  for (int i = 0; i<taille; i++)
  {
    if (getMaxInt(i) >0) maxi += getMaxInt(i);
    if (getMinInt(i)<0) min += getMinInt(i);
  }
  //maxi+=3*precision;
  //min-=3*precision;
  int taille1 = maxi+1;
  int taille2 = -min+1;
  pos[0] = new long double [taille1];
  pos[1] = new long double [taille1];
  for (int i = 0; i<=maxi; i++)
  {
    pos[0][i]=0;
    pos[1][i]=0;
  }
  neg[0] = new long double [taille2];
  neg[1] = new long double [taille2];
  for (int i = 0; i<=-min; i++)
  {
    neg[0][i]=0;
    neg[1][i]=0;
  }
  t = (int) pow( ( float )4, (taille-1 ) );
  for (int j = 0; j<4; j++)
  {
    if (j==0||j==3) pourc = pAT;
    else pourc = pGC;
    if (matInt[j][0]>=0)
    {
      pos[0][matInt[j][0]]+=pourc;
    }
    else
    {
      neg[0][-matInt[j][0]]+=pourc;
    }
  }
  for (int i = 1; i<taille; i++)
  {
    for (int k = 0; k<=maxi; k++)
    {
      if (pos[tour][k]!=0)
      {
        for (int j = 0; j<4; j++)
        {
          l[j] = k + matInt[j][i];
        }
        o = pos[tour][k];
        pos[tour][k]=0;
        for (int j = 0; j<4; j++)
        {
          if (j==0||j==3) pourc = pAT;
          else pourc = pGC;
          if (l[j]>=0)
          {
            if (l[j] > maxi)
              cout << "depacement " << l[j] << " " << maxi << endl;
            pos[tour2][l[j]]+=o*pourc ;
          }
          else
          {
            if (-l[j] > -min)
              cout << "depacement neg" << -l[j] << " " << -min << endl;
            neg[tour2][-l[j]]+=o*pourc ;
          }
          cpt+=o;
        }
      }
    }
    for (int k = 0; k<=-min; k++)
    {
      if (neg[tour][k]!=0)
      {
        for (int j = 0; j<4; j++)
        {
          l[j] = -k + matInt[j][i];
        }
        o=neg[tour][k];
        neg[tour][k]=0;
        for (int j = 0; j<4; j++)
        {
          if (j==0||j==3) pourc = pAT;
          else pourc = pGC;
          if (l[j]>=0)
          {
            if (l[j] > maxi)
              cout << "depacement " << l[j] << " " << maxi << endl;
            pos[tour2][l[j]]+=o*pourc ;
          }
          else
          {
            if (-l[j] > -min)
              cout << "depacement neg " << -l[j] << " " << -min << endl;
            neg[tour2][-l[j]]+=o*pourc ;
          }
          cpt+=o;
        }
      }
    }
    ech = tour;
    tour = tour2;
    tour2 = ech;
  }
  somCumul = 0;
  for (int k = 0; k<=maxi; k++)
  {
    pos[tour2][k] = pos[tour][k];
  }
  for (int k = 0; k<=-min; k++)
  {
    neg[tour2][k] = neg[tour][k];
  }
  somCumul = 0;
  for (int k = maxi; k>=0; k--)
  {
    somCumul += pos[0][k];
    pos[1][k]=somCumul;
  }
  for (int k = 1; k<=-min; k++)
  {
    somCumul += neg[0][k];
    neg[1][k]=somCumul;
  }
  if (neg[1][-min] > 1.01) cout << "ATTTTTTTT : " << nom << " " << neg[1][-min] << endl;
  if (neg[1][-min] <0.99) cout << "ATTTTTTTT : " << nom << " " << neg[1][-min] << endl;
}

void Matrice::calcDistrib2(int tailleInter)
{
  float pGC = pourGC/2;
  float pAT = (1-pourGC)/2;
  float pourc;
  short tour = 0, tour2 = 1, ech;
  int l[4], t;
  float o;
  long double somCumul;
  min =0;
  maxi = 0;
  float cpt;
  for (int i = 0; i<tailleInter; i++)
  {
    maxi += getMaxInt(i);
    min += getMinInt(i);
  }
  maxi+=3*precision; if (maxi<0) maxi=0;
  min-=3*precision;
  int taille1 = maxi+1;
  int taille2 = -min+1;
  pos[0] = new long double [taille1];
  pos[1] = new long double [taille1];
  for (int i = 0; i<=maxi; i++)
  {
    pos[0][i]=0;
    pos[1][i]=0;
  }
  neg[0] = new long double [taille2];
  neg[1] = new long double [taille2];
  for (int i = 0; i<=-min; i++)
  {
    neg[0][i]=0;
    neg[1][i]=0;
  }
  t = (int) pow( ( float )4, (tailleInter-1 ) );
  for (int j = 0; j<4; j++)
  {
    if (j==0||j==3) pourc = pAT;
    else pourc = pGC;
    if (matInt[j][0]>=0)
    {
      pos[0][matInt[j][0]]+=pourc;
    }
    else
    {
      neg[0][-matInt[j][0]]+=pourc;
    }
  }
  for (int i = 1; i<tailleInter; i++)
  {
    for (int k = 0; k<=maxi; k++)
    {
      if (pos[tour][k]!=0)
      {
        for (int j = 0; j<4; j++)
        {
          l[j] = k + matInt[j][i];
        }
        o = pos[tour][k];
        pos[tour][k]=0;
        for (int j = 0; j<4; j++)
        {
          if (j==0||j==3) pourc = pAT;
          else pourc = pGC;
          if (l[j]>=0)
          {
            if (l[j] > maxi)
              cout << "depacement " << l[j] << " " << maxi << endl;
            pos[tour2][l[j]]+=o*pourc ;
          }
          else
          {
            if (-l[j] > -min)
              cout << "depacement neg" << -l[j] << " " << -min << endl;
            neg[tour2][-l[j]]+=o*pourc ;
          }
          cpt+=o;
        }
      }
    }
    for (int k = 0; k<=-min; k++)
    {
      if (neg[tour][k]!=0)
      {
        for (int j = 0; j<4; j++)
        {
          l[j] = -k + matInt[j][i];
        }
        o=neg[tour][k];
        neg[tour][k]=0;
        for (int j = 0; j<4; j++)
        {
          if (j==0||j==3) pourc = pAT;
          else pourc = pGC;
          if (l[j]>=0)
          {
            if (l[j] > maxi)
              cout << "depacement " << l[j] << " " << maxi << endl;
            pos[tour2][l[j]]+=o*pourc ;
          }
          else
          {
            if (-l[j] > -min)
              cout << "depacement neg " << -l[j] << " " << -min << endl;
            neg[tour2][-l[j]]+=o*pourc ;
          }
          cpt+=o;
        }
      }
    }
    ech = tour;
    tour = tour2;
    tour2 = ech;
  }
  somCumul = 0;
  for (int k = 0; k<=maxi; k++)
  {
    pos[tour2][k] = pos[tour][k];
  }
  for (int k = 0; k<=-min; k++)
  {
    neg[tour2][k] = neg[tour][k];
  }
  somCumul = 0;
  for (int k = maxi; k>=0; k--)
  {
    somCumul += pos[0][k];
    pos[1][k]=somCumul;
  }
  for (int k = 1; k<=-min; k++)
  {
    somCumul += neg[0][k];
    neg[1][k]=somCumul;
  }
  if (neg[1][-min] > 1.01) cout << "ATTTTTTTT2 : " << nom << " " << neg[1][-min] << endl;
  if (neg[1][-min] <0.99) cout << "ATTTTTTTT2 : " << nom << " " << neg[1][-min] << endl;
}


void Matrice::RempliPoids()
{
  debTest = -1;
  int seuil2;
  poids = new float [taille+1];
  for (int i = 0; i<taille; i++)
  {
    poids[i]=0;
  }
  calcDistrib();
  seuil = calcSeuilMax(pow( ( long double )exp(1.0), -pValeur ));
  for (int i = 1; i<taille; i++)
  {
    seuil2 = seuil - calcMax(i);
    calcDistrib2(i);
    poids[i]= 1-calcPval(seuil2);
    if (debTest==-1 && poids[i]>0) debTest=i; 
  }
  calcDistrib2(taille-1);
  poids[taille] = 1-calcPval(seuil-getMaxInt(taille-1));
  if (debTest ==-1) debTest = taille;
}

int Matrice::calcSeuilExact(int t)
{
  int s=0;
  for (int i=0; i< t; i++)
  {
    s+=getMaxInt(i);
  }
  return s;
}



