#include "Matrices.h"
#include <fstream>
#include <ctype.h>
#include <algorithm>

Matrices::Matrices( string f, int prec, float pgc, int p, int pVal, bool b )
{
  //cout << "Loading matrices from " << f << " ..." << endl;
  
  pValeur = pVal;
  precision = prec;
  fichierMatrices = f;
  pourGC = pgc;
  psc = p;
  lectFicMatrices();
  remplitTab();
  sort( matriceMatrices, matriceMatrices + nbMatrice, more_mat() );
  param();
  createTbCorres();
  calcSeuil();
  if (b) DifMatrices();
}

Matrices::Matrices( Matrice * * m, int nM, float pgc, int p, int pVal )
{
  pValeur = pVal;
  pourGC = pgc;
  psc = p;
  nbMatrice = nM;
  matriceMatrices = m;
  //sort( matriceMatrices, matriceMatrices + nbMatrice, more_mat() );
  param();
  calcSeuil();
}

int Matrices::getPrecision()
{
  return precision;
}
int Matrices::getPValeur()
{
  return pValeur;
}
int Matrices::getPsc()
{
  return psc;
}

float Matrices::getpGC()
{
  return pourGC;
}
int Matrices::getNbMatrice()
{
  return nbMatrice;
}

int Matrices::getTailleMaxMatrice()
{
  return tailleMaxMatrice;
}

int Matrices::getTailleMinMatrice()
{
  return tailleMinMatrice;
}

int * Matrices::getTabNbMatriceTailleSup()
{
  return tabNbMatriceTailleSup;
}

int Matrices::getTabNbMatriceTailleSup( int i )
{
  return tabNbMatriceTailleSup[i];
}

Matrice * Matrices::getMatrice( short i )
{
  return matriceMatrices[i];
}

float * * Matrices::getTabDifVal()
{
  return tabDifVal;
}

float Matrices::getTabDifVal( short i, short j )
{
  return tabDifVal[i] [j];
}



int Matrices::getTabDifDec( short i, short j )
{
  return tabDifDec[i] [j];
}

int Matrices::getSeuil( int i )
{
  return seuils[i];
}


int Matrices::getCorres( string n )
{
  return ( tbCorres.find( n ) )->second;
}

void Matrices::calcSeuil()
{
  seuils = new int[nbMatrice];
  for ( int i = 0; i < nbMatrice; i++ ) {
    seuils[i] = matriceMatrices[i]->calcSeuilMax(pow( ( long double )exp(1.0), -pValeur ));
    cout << "[mats]   " << matriceMatrices[i]->getNom() << "\t" << seuils[i] << endl;
  }
}

void Matrices::DifMatrices()
{
  int i, j, k, difTaille, taillei, taillej, taille;
  float * ad;
  tabDifVal = new float * [nbMatrice];
  tabDifDec = new int * [nbMatrice];
  float tab[tailleMaxMatrice * 2 + 1];
  long double d;
  int a, b, eMax, fMax;
  for ( i = 0; i < nbMatrice; i++ )
  {
    tabDifVal[i] = new float[nbMatrice];
    tabDifDec[i] = new int [nbMatrice];
  }
  for ( i = 0; i < nbMatrice; i++ )
  {
    taillei = matriceMatrices[i]->getTaille();
    fMax = getSeuil(i);
    for ( j = 0; j < nbMatrice; j++ )
    {
      eMax = getSeuil(j);
      if ( i != j )
      {
        taillej = matriceMatrices[j]->getTaille();
        taille = min( taillei, taillej ) - 1;
        difTaille = taillei - taillej;
        for ( k = -taillej; k <= taillei; k++ )
        {
          a = DifPosMaxCons( i, j, k);
          if (a!=-1)
          {
            b = DifPosMaxCons( j, i, -k);
            if (b!=-1)
            {
              d = matriceMatrices[i]->calcPval(eMax-a)- matriceMatrices[i]->calcPval(eMax+b);
            }
            else d=1;
          }
          else   d=1;
          tab[k + taillej] = d;
        }
        ad = min_element( tab, tab + ( taillei + taillej + 1 ) );
        tabDifDec[i] [j] = ( ad - tab );
        tabDifVal[i] [j] = * ad;
        tabDifDec[i] [j] -= taillej;
      }
      else
      {
        tabDifDec[i] [j] = 0;
        tabDifVal[i] [j] = 0;
      }
    }
  }
}


void Matrices::createTbCorres()
{
  typedef pair < string, int > psi;
  typedef list < psi > lv;

  lv l;
  for ( int i = 0; i < nbMatrice; i++ )
  {
    psi mm(matriceMatrices[i]->getNom(), i);

    l.push_back(mm);
  }
  map < string, int > tb( l.begin(), l.end() );
  tbCorres = tb;
}


int Matrices::DifPosMaxCons( int k, int l, int decalage, bool b )
{
  short j;
  float x = 0.75, y = 0.5, f0, f1;
  int i, taillek, taillel, difTaille, taille, taille2, indM, indF0, indF1, cpt = 0;
  int scorek = 0, scorel = 0, fondMin, fondMax;
  taillek = matriceMatrices[k]->getTaille();
  taillel = matriceMatrices[l]->getTaille();
  difTaille = taillek - taillel;
  if ( decalage >= 0 )
  {
    taille = min( taillel, taillek - decalage );
    taille2 = max( taillel, taillek - decalage );
  }
  else
  {
    taille = min( taillek, taillel + decalage );
    taille2 = max( taillek, taillel + decalage );
  }
  long double dif[taille] [4];
  if ( !b )
  {
    fondMin = (int) roundl(log( 0.15 )*precision);
    fondMax = (int) roundl(log( 0.35 )*precision);
  }
  else
  {
    fondMin = (int) roundl(log( 0.25 )*precision);
    fondMax = (int) roundl(log( 0.25 )*precision);
  }

  if ( decalage >= 0 )
  {
    for ( i = 0; i < decalage; i++ )
    {
      indF0 = matriceMatrices[k]->getMaxFreqInd(i);
      if (matriceMatrices[k]->getMatFreq(indF0, i) > x) return -1;
      scorek += matriceMatrices[k]->getMaxDistInt(i);
      scorel += fondMin;
      cpt++;
    }
    if ( taillek - decalage > taillel )
    {
      for ( i = 0; i < taillel; i++ )
      {
        for ( j = 0; j < 4; j++ )
        {
          dif[i][j] = matriceMatrices[k]->getMatDist( j, i + decalage ) - matriceMatrices[l]->getMatDist( j, i );
        }
        indM = max_element( dif[i], dif[i] + j ) - dif[i];
        indF0 = matriceMatrices[k]->getMaxFreqInd(i + decalage);
        indF1 = matriceMatrices[l]->getMaxFreqInd(i);
        f0 = matriceMatrices[k]->getMatFreq(indF0, i+decalage);
        f1 = matriceMatrices[l]->getMatFreq(indF1, i);
        if (( f0 > x) && (matriceMatrices[l]->getMatFreq(indF0, i) < y*f0))
          return -1 ;
        else if (( f1 > x ) && (matriceMatrices[k]->getMatFreq(indF1, i + decalage) < y*f1))
          return -1 ;
        scorek += matriceMatrices[k]->getMatDistInt( indM, i + decalage );
        scorel += matriceMatrices[l]->getMatDistInt( indM, i );
        cpt++;
      }
      for ( i = taillel; i < taillek - decalage; i++ )
      {
        indF0 = matriceMatrices[k]->getMaxFreqInd(i);
        if (matriceMatrices[k]->getMatFreq(indF0, i) > x) return -1 ;
        scorek += matriceMatrices[k]->getMaxDistInt( i );
        scorel += fondMin;
        cpt++;
      }
    }
    else
    {
      for ( i = 0; i < taillek - decalage; i++ )
      {
        for ( j = 0; j < 4; j++ )
        {
          dif[i] [j] = matriceMatrices[k]->getMatDist( j, i + decalage ) - matriceMatrices[l]->getMatDist( j, i );
        }
        indM = max_element( dif[i], dif[i] + j ) - dif[i];
        indF0 = matriceMatrices[k]->getMaxFreqInd(i + decalage);
        indF1 = matriceMatrices[l]->getMaxFreqInd(i);
        f0 = matriceMatrices[k]->getMatFreq(indF0, i+ decalage);
        f1 = matriceMatrices[l]->getMatFreq(indF1, i) ;
        if (( f0> x) && (matriceMatrices[l]->getMatFreq(indF0, i) < y*f0))
          return -1 ;
        else if ((f1> x) && (matriceMatrices[k]->getMatFreq(indF1, i + decalage) < y*f1))
          return -1 ;
        scorek += matriceMatrices[k]->getMatDistInt( indM, i + decalage );
        scorel += matriceMatrices[l]->getMatDistInt( indM, i );
        cpt++;
      }
      for ( i = taillek - decalage; i < taillel; i++ )
      {
        indF1 = matriceMatrices[l]->getMaxFreqInd(i);
        if (matriceMatrices[l]->getMatFreq(indF1, i) > x ) return -1 ;
        scorel += matriceMatrices[l]->getMinDistInt( i );
        scorek += fondMax;
        cpt++;
      }
    }
  }
  else
  {
    for ( i = 0; i < -decalage; i++ )
    {
      indF1 = matriceMatrices[l]->getMaxFreqInd(i);
      if (matriceMatrices[l]->getMatFreq(indF1, i) > x ) return -1 ;
      scorel += matriceMatrices[l]->getMinDistInt( i );
      scorek += fondMax;
      cpt++;
    }
    if ( taillek > taillel + decalage )
    {
      for ( i = 0; i < taillel + decalage; i++ )
      {
        for ( j = 0; j < 4; j++ )
        {
          dif[i] [j] = matriceMatrices[k]->getMatDist( j, i ) - matriceMatrices[l]->getMatDist( j, i - decalage );
        }
        indM = max_element( dif[i], dif[i] + j ) - dif[i];
        indF0 = matriceMatrices[k]->getMaxFreqInd(i);
        indF1 = matriceMatrices[l]->getMaxFreqInd(i- decalage );
        f0 = matriceMatrices[k]->getMatFreq(indF0, i);
        f1 = matriceMatrices[l]->getMatFreq(indF1, i- decalage );
        if ((f0 > x) && (matriceMatrices[l]->getMatFreq(indF0, i- decalage ) < y*f0))
          return -1 ;
        else if (( f1> x ) && (matriceMatrices[k]->getMatFreq(indF1, i) < y*f1))
          return -1 ;
        scorek += matriceMatrices[k]->getMatDistInt( indM, i );
        scorel += matriceMatrices[l]->getMatDistInt( indM, i - decalage );
        cpt++;
      }
      for ( i = taillel + decalage; i < taillek; i++ )
      {
        indF1 = matriceMatrices[l]->getMaxFreqInd(i);
        if (matriceMatrices[l]->getMatFreq(indF1, i) > x ) return -1 ;
        scorek += matriceMatrices[k]->getMaxDistInt( i );
        scorel += fondMin;
        cpt++;
      }
    }
    else
    {
      for ( i = 0; i < taillek; i++ )
      {
        for ( j = 0; j < 4; j++ )
        {
          dif[i] [j] = matriceMatrices[k]->getMatDist( j, i ) - matriceMatrices[l]->getMatDist( j, i - decalage );
        }
        indM = max_element( dif[i], dif[i] + j ) - dif[i];
        indF0 = matriceMatrices[k]->getMaxFreqInd(i);
        indF1 = matriceMatrices[l]->getMaxFreqInd(i- decalage );
        f0 = matriceMatrices[k]->getMatFreq(indF0, i);
        f1 = matriceMatrices[l]->getMatFreq(indF1, i- decalage );
        if (( f0> x) && (matriceMatrices[l]->getMatFreq(indF0, i- decalage ) < y*f0))
          return -1 ;
        else if (( f1> x ) && (matriceMatrices[k]->getMatFreq(indF1, i) < y*f1))
          return -1 ;
        scorek += matriceMatrices[k]->getMatDistInt( indM, i );
        scorel += matriceMatrices[l]->getMatDistInt( indM, i - decalage );
        cpt++;
      }
      for ( i = taillek; i < taillel + decalage; i++ )
      {
        indF1 = matriceMatrices[l]->getMaxFreqInd(i);
        if (matriceMatrices[l]->getMatFreq(indF1, i) > x ) return -1 ;
        scorel += matriceMatrices[l]->getMinDistInt( i );
        scorek += fondMax;
        cpt++;
      }
    }
  }
  return (scorek - scorel);
}



void Matrices::remplitTab()
{
  // Remplit le tableau contenant les matrices
  int i;
  matriceMatrices = new Matrice * [nbMatrice];
  for ( i = 0; i < nbMatrice; i++ )
  {
    //cout << i << " " << nbMatrice << " " << fichiersMatrices[i] << endl;
    matriceMatrices[i] = new Matrice( chemin, fichiersMatrices[i], precision, psc, pValeur, pourGC);
  }
  delete[] fichiersMatrices;
}

void Matrices::param()
{
  int i, nb;
  tailleMaxMatrice = matriceMatrices[0]->getTaille();
  tailleMinMatrice = matriceMatrices[nbMatrice-1]->getTaille();
  tailleMatrices = new int[tailleMaxMatrice + 1];
  for ( i = 0; i < tailleMaxMatrice + 1; i++ )
  {
    tailleMatrices[i] = 0;
  }
  for ( i = 0; i < nbMatrice; i++ )
  {
    int t = matriceMatrices[i]->getTaille();
    tailleMatrices[t] += 1;
  }
  nb = 0;
  tabNbMatriceTailleSup = new int[tailleMaxMatrice + 1];
  tabNbMatriceTailleSup[tailleMaxMatrice] = 0;
  for ( i = tailleMaxMatrice - 1; i >= 0; i-- )
  {
    nb += tailleMatrices[i + 1];
    tabNbMatriceTailleSup[i] = nb;
  }
}

void Matrices::lectFicMatrices()
{
  
  
  ifstream f(fichierMatrices.data());
  if (!f) {
    cerr << "The file " << fichierMatrices.data() << " is missing." << endl;
    exit( -1 );
  } 
  
  vector<string> v;

  // first read the path
  if (!f.eof()) {
    getline(f,chemin);
  } else {
    cerr << "The file " << fichierMatrices.data() << " is empty." << endl;
    exit( -1 );
  }

  // next read the matrices filenames
  nbMatrice = 0;
  while (!f.eof()) {
    string str;
    getline(f,str);
    int beg = 0;
/*    while (!isspace(str.at(beg))) beg++;*/
    int end = str.length();
/*    while (!isspace(str.at(end))) end--;*/
    if (str.size() > 0) {
      v.insert(v.end(),str.substr(beg,end));
      nbMatrice++;
    }
  }
  f.close();
  
  if (nbMatrice == 0) {
    cerr << "The file " << fichierMatrices.data() << " does not contain any matrix." << endl;
    exit( -1 );
  }
  
  fichiersMatrices = new string[nbMatrice];
  for (int i = 0; i < nbMatrice; i++) {
    //cout << "Matrix " << i << " " << (string)v.at(i) << endl;
    fichiersMatrices[i] = (string)v.at(i);
  }
  /*
  int i = 0;
  bool bchem = false;
  ifstream fe( fichierMatrices.data(), ios_base::in );
  if ( !fe )
  {
    cerr << "The file " << fichierMatrices.data() << " is missing." << endl;
    exit( -1 );
  }
  if ( fe.eof() )
  {
    cerr << "The file " << fichierMatrices.data() << " is empty." << endl;
    exit( -1 );
  }
  char * tampon;
  string buf;
  fe.seekg( 0, ios::end );
  int longueur_fichier = fe.tellg();
  fe.seekg( 0, ios::beg );
  tampon = new char[longueur_fichier];
  fe.read( tampon, longueur_fichier );
  fe.close();
  // Compte le nombre de matrice
  nbMatrice = 0;
  buf = tampon;
  delete[] tampon;
  string::size_type debut = buf.find_first_not_of( " \t\n" );
  while ( debut != string::npos )
  {
    string::size_type pos = buf.find_first_of( " \t\n", debut );
    debut = buf.find_first_not_of( " \t\n", pos );
    nbMatrice++;
  }
  nbMatrice -= 1;
  // Cree un tableau donnant pour chaque ident interne de matrice son nom
  fichiersMatrices = new string[nbMatrice];
  debut = buf.find_first_not_of( " \t\n" );
  while ( i < ( nbMatrice ) )
  {
    cout << "Lecture de la matrice " << i << endl;
    string::size_type pos = buf.find_first_of( " \t\n", debut );
    if ( !bchem )
    {
      chemin = buf.substr( debut, pos - debut );
      bchem = true;
      cout << "Chemin " << chemin << endl;
    }
    else
    {
      if ( pos != string::npos )
      {
        fichiersMatrices[i] = buf.substr( debut, pos - debut );
      }
      else
      {
        fichiersMatrices[i] = buf.substr(debut, longueur_fichier-debut);

      }
      i++;
    }
    debut = buf.find_first_not_of( " \t\n", pos );
  }
   */
}


