#include "Metier.h"
//#define GCV
using namespace std;

Metier::Metier( StructMatrice * strucmat, vector < Cluster2 > lc, Matrices * mT, Matrices * mM, int pGC, string res, bool loc )
{
  local=loc;
  ficRes=res;
  pourGC=pGC;
  sm = strucmat;
  matricesT = mT;
  matricesM = mM;
  precision=mT->getMatrice(0)->getPrecision();
  nbMatrice = matricesM->getNbMatrice();
  nbTab = sm->getNbTab();
  scoreMatrice = new long[nbMatrice];
  nbGC = new long[nbMatrice];
  tmax = matricesM->getTailleMaxMatrice();
  tmin = matricesM->getTailleMinMatrice();
  codeOld = new int[nbTab];
  for(int i =0; i< nbTab; i++)
  {
    codeOld[i] = 0;
  }
  listClust = lc;
  nbMat = new short[nbMatrice];
  bS = new int * [nbMatrice];
  bI = new int * [nbMatrice];
  nbTest = new int * [nbMatrice];
  nbTest2 = new int * [nbMatrice];
  nbTestI = new int [nbMatrice];
  dec = new short * [nbMatrice];
  decI = new short [nbMatrice];
  decS = new short [nbMatrice];
  seuil = new int * [nbMatrice];
  seuilN = new int [nbMatrice];
  taille = new short * [nbMatrice];
  tailleN = new short [nbMatrice];
  mat = new short * [nbMatrice];
  noyau = new short [nbMatrice];
  matrice = new Matrice * * [nbMatrice];
  noy = new Matrice * [nbMatrice];
  for ( int j = 0; j < nbMatrice; j++ )
  {
    nbMat[j] = listClust[j].getNbMat();
    bS[j] = new int[nbMat[j]];
    bI[j] = new int[nbMat[j]];
    nbTest[j] = new int[nbMat[j]];
    nbTest2[j] = new int[nbMat[j]];
    dec[j] = new short[nbMat[j]];
    seuil[j] = new int[nbMat[j]];
    taille[j] = new short[nbMat[j]];
    mat[j] = new short[nbMat[j]];
    matrice[j] = new Matrice * [nbMat[j]];
    noyau[j] = j;
    noy[j] = listClust[j].getMoyenne();
    seuilN[j] = matricesM->getSeuil(j);
    tailleN[j]=listClust[j].getMoyenne()->getTaille();
    for ( int k = 0; k < nbMat[j]; k++ )
    {
      mat[j] [k] = listClust[j].getMat( k );
      seuil[j] [k] = matricesT->getSeuil( mat[j] [k] );
      dec[j] [k] = matricesT->getTabDifDec(noyau[j], mat[j] [k]);
      matrice[j] [k] = matricesT->getMatrice( mat[j] [k] );
      taille[j] [k] = matrice[j] [k]->getTaille();
      if (nbMat[j]==1) dec[j][k]=0;
      else  dec[j][k] =matrice[j] [k]->getDec();
      bI[j] [k] = difPosMax(noy[j], matrice[j][k], dec[j][k] );
      bS[j] [k] = difPosMax(matrice[j][k], noy[j], -dec[j][k] );
      nbTest[j][k] = seuil[j][k] - bI[j][k];
      nbTest2[j][k] = seuil[j][k] + bS[j][k];
    }
    nbTestI[j] = *min_element( nbTest[j], nbTest[j]+nbMat[j]);
    if(nbMat[j]>1)
    {
      decS[j]=*max_element( dec[j], dec[j]+nbMat[j]);
      decI[j]=*min_element( dec[j], dec[j]+nbMat[j]);
    }
    else
    {
      decS[j]=0;
      decI[j]=0;
    }
  }
  decM=*max_element( decS, decS+nbMatrice);if (decM<0) decM=0;
  decm=*min_element( decI, decI+nbMatrice);if(decm>0) decm=0;
  calcFond();
  espMax= new int*[nbTab];
  for(int i =0; i<nbTab; i++)
  {
    espMax[i]=new int [nbMatrice];
    for(int j =0; j<nbMatrice; j++)
    {
      espMax[i][j]=(noy[j]->getGLB(sm->getDecoupageCumul(i)))+(sm->getDecoupageCumul(i)*(int)roundl(log(0.15)*precision));
    }
  }
}

void Metier::setSequence( Sequence * s )
{
  seq = s;
  seqCode = seq->getSeqCode();
  tailleSeq = seq->getLength();
  ts = tailleSeq - 1;
  maxi = tailleSeq - tmin ;
  mini = tailleSeq - tmax ;
}


long * Metier::returnIt( unsigned long debut, unsigned long longeur )
                     {
                       if (local)
                       {
                         if (debut>100 && (ts-debut)>100 && debut/10==0)
                         {
                           seq->setPourGC(debut);
                           pourGC = seq->getPourGC();
                         }
                       }
                       for ( i = 0; i < nbMatrice; i++ )
                       {
                         scoreMatrice[i] = 0;
                         nbGC[i] = 0;
                       }
                       if ( longeur < tmax )
                       {
                         nbTabUtile = 0;
                         while ( longeur > sm->getDecoupageCumul( nbTabUtile + 1 ) )
                         {
                           nbTabUtile++;
                         }
                         nbTabUtile++;
                       }
                       else
                       {
                         nbTabUtile = nbTab;
                       }
                       for ( i = 0; i < nbTabUtile; i++ )
                       {
                         m = debut + sm->getDecoupageCumul( i );
                         n = sm->getDecoupage( i );
                         o = m + n;
                         if (o > tailleSeq) o=tailleSeq;
                         p = ( int )( pow( ( float )4, sm->getDecoupage( i ) - 1 ) );
                         cpt = 0;
                         if ( debut == 0 )
                         {
                           for ( j = m; j < o; j++ )
                           {
                             cpt = ( cpt << 2 ) + seqCode[j];
                           }
                         }
                         else
                         {
                           cpt = codeOld[i];
                           cpt -= seqCode[m - 1] * p;
                           cpt = cpt << 2;
                           cpt += seqCode[o - 1];
                         }
                         codeOld[i] = cpt;
                         nbMatParcourirOld = nbMatParcourir;
                         nbMatParcourir = matricesM->getTabNbMatriceTailleSup( sm->getDecoupageCumul(i));
                         switch(i)
                         {
                         case 0 :
                           break;
                         case 1 :
                           for (;nbMatParcourir>nbMatNonParcourir; nbMatParcourir--)
                           {
                             if (scoreMatrice[nbMatParcourir-1] < espMax[i][nbMatParcourir-1])
                             {
                               scoreMatrice[nbMatParcourir-1] = -100000;;
                             }
                             else
                             {
                               break;
                             }
                           }
                           break;
                         default :
                           nbMatParcourir = min (nbMatParcourirOld, nbMatParcourir);
                           for (;nbMatParcourir>nbMatNonParcourir; nbMatParcourir--)
                           {
                             if (scoreMatrice[nbMatParcourir-1] < espMax[i][nbMatParcourir-1])
                             {
                               scoreMatrice[nbMatParcourir-1] = -100000;
                             }
                             else
                             {
                               break;
                             }
                           }
                           break;
                         }
                         if(nbMatParcourir)
                         {
                           accesMatCode = sm->getStructMatrice( i, cpt );
                           for ( short l = nbMatNonParcourir; l < nbMatParcourir; l++ )
                           {
                             accesMatCode2  = accesMatCode[l];
                             scoreMatrice[l] += accesMatCode2[0];
                             nbGC[l] += accesMatCode2[1];
                           }
                         }
                       }
                       for (int l=0; l<nbMatrice; l++)
                       {
                         if (scoreMatrice[l]!=-100000)
                         {
                           scoreMatrice[l]-=fond[pourGC][tailleN[l]][nbGC[l]];
                         }
                       }
                       return scoreMatrice;
                     }



                     int Metier::it( Matrice * mat, unsigned long debut, int taille)
                     {
                       int s = 0, nbGC=0, c;
                       for ( int j = 0; j < taille; j++ )
                       {
                         c = seqCode[debut + j];
                         s += mat->getMatDistInt(c , j );
                         if (c==1||c==2) nbGC++;
                       }
                       s -= fond[pourGC][taille][nbGC];
                       return s;

                     }

                     void Metier::lesHits2()
                     {
                       streambuf * f = cout.rdbuf();
                       ofstream fs( ficRes.data(), ios_base::app );
                       if ( fs.is_open())
                         cout.rdbuf(fs.rdbuf());
		       cout << "Location\t\tMatrix\t\tScore"<<endl;
                       int i;
                       nbMatNonParcourir=0;
                       for (i =0; i<mini; i++)
                       {
                         scoreMatrice = returnIt( i, tmax );
                         for(int j=0; j< nbMatrice; j++)
                         {
                           if (scoreMatrice[j]>=matricesM->getSeuil(j))
                           {
                             for ( int k = 0; k < nbMat[j]; k++ )
                             {
                               cout <<i+1+dec[j][k]<<"\t\t" <<matrice[j][k]->getNom()<< "\t\t"<<(double)scoreMatrice[j]/precision<<endl;
                             }
                             cout << endl;
                           }
                         }
                       }
                       for (; i<maxi; i++)
                       {
                         nbMatNonParcourir = matricesM->getTabNbMatriceTailleSup(seq->getLength() - i);
                         scoreMatrice = returnIt( i, seq->getLength() - i );
                         for(int j=nbMatNonParcourir; j< nbMatrice; j++)
                         {
                           if (scoreMatrice[j]>=matricesM->getSeuil(j))
                           {
                             for ( int k = 0; k < nbMat[j]; k++ )
                             {
                               cout <<i+1+dec[j][k]<<"\t\t" <<matrice[j][k]->getNom()<< "\t\t"<<(double)scoreMatrice[j]/precision<<endl;
                             }
                             cout << endl;
                           }
                         }
                       }
                       cout.rdbuf(f);
                     }

                     void Metier::calcDistribMixte(Matrice* m1, Matrice* m2, int s1, int s2, int dec)
                     {
                       Distribution dist(m1, m2, s1, s2, 0.5, dec);
                       if(dist.getFN()>FN) FN = dist.getFN();
                       if(dist.getFP()>FP) FP = dist.getFP();
                     }

                     void Metier::calcFond()
                     {
                       fond = new long ** [9];
                       for(int i=0; i<9; i++)
                       {
                         float f = 0.05*(i+6);
                         fond[i] = new long * [(tmax+1)];
                         for(int j = 0; j<tmax+1 ; j++)
                         {
                           fond[i][j] = new long[(j+1)];
                           for (int k=0; k<j+1; k++)
                           {
                             fond[i][j][k]=k*(int)roundl((log(f/2)*precision))+(j-k)*(int)roundl(log((1-f)/2)*precision);
                           }
                         }
                       }
                     }

                     int Metier::difPosMax( Matrice *mk, Matrice *ml, int decalage)
                     {
                       short j;
                       int i, taillek, taillel, difTaille, taille, taille2, indM, cpt = 0;
                       int scorek = 0, scorel = 0, fondMin, fondMax;
                       taillek = mk->getTaille();
                       taillel = ml->getTaille();
                       difTaille = taillek - taillel;
                       if ( decalage >= 0 )
                       {
                         taille = min( taillel, taillek - decalage );
                         taille2 = max( taillel, taillek - decalage );
                       }
                       else
                       {
                         taille = min( taillek, taillel + decalage );
                         taille2 = max( taillek, taillel + decalage );
                       }
                       long double dif[taille] [4];
                       fondMin = (int) roundl(log( 0.15 )*precision);
                       fondMax = (int) roundl(log( 0.35 )*precision);
                       if ( decalage >= 0 )
                       {
                         for ( i = 0; i < decalage; i++ )
                         {
                           scorek += mk->getMaxDistInt(i);
                           cpt++;
                         }
                         if ( taillek - decalage > taillel )
                         {
                           for ( i = 0; i < taillel; i++ )
                           {
                             for ( j = 0; j < 4; j++ )
                             {
                               dif[i][j] = mk->getMatDist( j, i + decalage ) - ml->getMatDist( j, i );
                             }
                             indM = max_element( dif[i], dif[i] + j ) - dif[i];
                             scorek += mk->getMatDistInt( indM, i + decalage );
                             scorel += ml->getMatDistInt( indM, i );
                             cpt++;
                           }
                           for ( i = taillel; i < taillek - decalage; i++ )
                           {
                             scorek += mk->getMaxDistInt( i );
                             cpt++;
                           }
                         }
                         else
                         {
                           for ( i = 0; i < taillek - decalage; i++ )
                           {
                             for ( j = 0; j < 4; j++ )
                             {
                               dif[i] [j] = mk->getMatDist( j, i + decalage ) - ml->getMatDist( j, i );
                             }
                             indM = max_element( dif[i], dif[i] + j ) - dif[i];
                             scorek += mk->getMatDistInt( indM, i + decalage );
                             scorel += ml->getMatDistInt( indM, i );
                             cpt++;
                           }
                           for ( i = taillek - decalage; i < taillel; i++ )
                           {
                             scorel += ml->getMinDistInt( i );
                             cpt++;
                           }
                         }
                       }
                       else
                       {
                         for ( i = 0; i < -decalage; i++ )
                         {
                           scorel += ml->getMinDistInt( i );
                           cpt++;
                         }
                         if ( taillek > taillel + decalage )
                         {
                           for ( i = 0; i < taillel + decalage; i++ )
                           {
                             for ( j = 0; j < 4; j++ )
                             {
                               dif[i] [j] = mk->getMatDist( j, i ) - ml->getMatDist( j, i - decalage );
                             }
                             indM = max_element( dif[i], dif[i] + j ) - dif[i];
                             scorek += mk->getMatDistInt( indM, i );
                             scorel += ml->getMatDistInt( indM, i - decalage );
                             cpt++;
                           }
                           for ( i = taillel + decalage; i < taillek; i++ )
                           {
                             scorek += mk->getMaxDistInt( i );
                             cpt++;
                           }
                         }
                         else
                         {
                           for ( i = 0; i < taillek; i++ )
                           {
                             for ( j = 0; j < 4; j++ )
                             {
                               dif[i] [j] = mk->getMatDist( j, i ) - ml->getMatDist( j, i - decalage );
                             }
                             indM = max_element( dif[i], dif[i] + j ) - dif[i];
                             scorek += mk->getMatDistInt( indM, i );
                             scorel += ml->getMatDistInt( indM, i - decalage );
                             cpt++;
                           }
                           for ( i = taillek; i < taillel + decalage; i++ )
                           {
                             scorel += ml->getMinDistInt( i );
                             cpt++;
                           }
                         }
                       }
                       scorek -= fondMin*taillek;
                       scorel-=fondMax*taillel;
                       return (scorek - scorel);
                     }


                     void Metier::lesHitsExact()
                     {
                       nbMatNonParcourir=0;

                       streambuf * f = cout.rdbuf();
                       ofstream fs( ficRes.data(), ios_base::app );
                       if ( fs.is_open())
                         cout.rdbuf(fs.rdbuf());

			cout << "Location\t\tMatrix\t\tScore"<<endl;
                       long i = 0;
                       double s;
                       for ( int j = 0; j < nbMatrice; j++ )
                       {
                         for ( long k = 0; k < nbMat[j]; k++ )
                         {
                           if ( dec[j] [k] < 0 )
                           {
                             for ( int l = 0; l < -dec[j] [k]; l++ )
                             {
                               s = it( matrice[j] [k], l, taille[j][k]);
                               if ( s >= matricesT->getSeuil(mat[j][k]) )
                               {
                                 cout <<l+1<<"\t\t"<<matrice[j][k]->getNom()
                                 <<"\t\t"<<(double)s/precision<<endl;
                               }
                             }
                           }
                         }
                       }

                       long k;
                       for ( ; i <= decM; i++ )
                       {
                         scoreMatrice = returnIt( i, tmax );
                         for ( int j = 0; j < nbMatrice; j++ )
                         {
                           if (nbMat[j]==1)
                           {
                             if ( scoreMatrice[j] >= seuilN[j] )
                             {
                               cout <<i+1<<"\t\t"<<noy[j]->getNom()
                               <<"\t\t"<<(double)scoreMatrice[j]/precision<<endl;
                             }
                           }
                           else
                           {
                             if ( scoreMatrice[j] >= nbTestI[j] )
                             {
                               for ( k = 0; k < nbMat[j]; k++ )
                               {
                                 if ( scoreMatrice[j] + bS[j][k] >= seuil[j][k] )
                                 {
                                   if (!( i+dec[j][k]<0) )
                                   {
                                     s = it( matrice[j] [k], i + dec[j] [k], taille[j][k]);
                                     if ( s >= matricesT->getSeuil(mat[j][k]) )
                                     {
                                       cout <<i+dec[j] [k]+1<<"\t\t"<<matrice[j][k]->getNom()
                                       <<"\t\t"<<(double)s/precision<< endl;
                                     }
                                   }
                                 }
                               }
                             }
                           }
                         }
                       }

                       int d = min((int) mini, (int) tailleSeq+decm);
                       for ( ; i < d; i++ )
                       {
                         scoreMatrice = returnIt( i, tmax );
                         for ( int j = nbMatNonParcourir; j < nbMatrice; j++ )
                         {
                           if (nbMat[j]==1)
                           {
                             if ( scoreMatrice[j] >= seuilN[j] )
                             {
                               cout <<i+1<<"\t\t"<<noy[j]->getNom()
                               <<"\t\t"<<(double)scoreMatrice[j]/precision<< endl;
                             }
                           }
                           else
                           {
                             {
                               if ( scoreMatrice[j] >= nbTestI[j] )
                                 for ( k = 0; k < nbMat[j]; k++ )
                                 {
                                   if ( scoreMatrice[j] + bS[j][k] >= seuil[j][k] )
                                   {
                                     s = it( matrice[j] [k], i + dec[j] [k], taille[j][k]);
                                     if ( s >= matricesT->getSeuil(mat[j][k]) )
                                     {
                                       cout <<i+dec[j][k]+1<<"\t\t"<<matrice[j][k]->getNom()
                                       <<"\t\t"<<(double)s/precision<<endl;
                                     }
                                   }
                                 }
                             }
                           }
                         }
                       }

                       for ( ; i < maxi; i++ )
                       {
                         nbMatNonParcourir = matricesM->getTabNbMatriceTailleSup(seq->getLength() - i);
                         scoreMatrice = returnIt( i, seq->getLength() - i );
                         for ( int j = nbMatNonParcourir; j < nbMatrice; j++ )
                         {
                           if (nbMat[j]==1)
                           {
                             if ( scoreMatrice[j] >= seuilN[j] )
                             {
                               cout <<i+1<<"\t\t"<<noy[j]->getNom()
                               <<"\t\t"<<(double)scoreMatrice[j]/precision<< endl;
                             }
                           }
                           else
                           {
                             {
                               if ( scoreMatrice[j] >= nbTestI[j] )
                                 for ( k = 0; k < nbMat[j]; k++ )
                                 {
                                   if ( scoreMatrice[j] + bS[j][k] >= seuil[j][k] )
                                   {
                                     if(( i + dec[j][k] + taille[j] [k] < tailleSeq ) )
                                     {
                                       s = it( matrice[j] [k], i + dec[j] [k], taille[j][k]);
                                       if ( s >= matricesT->getSeuil(mat[j][k]) )
                                       {
                                         cout <<i+dec[j][k]+1<<"\t\t"<<matrice[j][k]->getNom()
                                         <<"\t\t"<<(double)s/precision<< endl;
                                       }
                                     }
                                   }
                                 }
                             }
                           }
                         }
                       }

                       for ( int j = 0; j < nbMatrice; j++ )
                       {
                         for ( long k = 0; k < nbMat[j]; k++ )
                         {
                           for (int l=tailleSeq-tailleN[j]+dec[j][k]+1;l<=tailleSeq-taille[j][k];l++)
                           {
                             s = it( matrice[j] [k], l, taille[j][k]);
                             if ( s >= matricesT->getSeuil(mat[j][k]) )
                             {
                               cout <<l+1<<"\t\t"<<matrice[j][k]->getNom()
                               <<"\t\t"<<(double)s/precision<<endl;
                             }
                           }
                         }
                       }

                       cout.rdbuf(f);
                     }
