#include "Metier2.h"
//#define GCV

Metier2::Metier2( StructMatrice * strucmat, Matrices * m, int pGC, string res, bool loc )
{
 local=loc;
 ficRes=res;
 pourGC=pGC;
 matrices = m;
 nbMatrice = matrices->getNbMatrice();
 precision=matrices->getMatrice(0)->getPrecision();
 sm = strucmat;
 nbTab = sm->getNbTab();
 tmax = matrices->getTailleMaxMatrice();
 tmin = matrices->getTailleMinMatrice();
 scoreMatrice = new long[nbMatrice];
 nbGC = new long[nbMatrice];
 codeOld = new int[nbTab];
 calcFond();
 espMax= new int*[nbTab];
 taille= new int [nbMatrice];
 for(int i =0; i<nbTab; i++)
 {
  espMax[i]=new int [nbMatrice];
  for(int j =0; j<nbMatrice; j++)
  {
   taille[j]=matrices->getMatrice(j)->getTaille();
   espMax[i][j]=(matrices->getMatrice(j)->getGLB(sm->getDecoupageCumul(i)))
   +(sm->getDecoupageCumul(i)*(int)roundl(log(0.15)*precision));
  }
 }
}

void Metier2::setSequence( Sequence * s )
{
 seq = s;
 seqCode = seq->getSeqCode();
 tailleSeq = seq->getLength();
 maxi = tailleSeq - tmin;
 mini = tailleSeq - tmax;
}


// computes the occurrences for all matrices whose length is less than 'longueur' at position 'debut'
long * Metier2::returnIt( unsigned long debut, unsigned long longeur )
{
 if(local)
 {
  if (debut>100 && (tailleSeq-1-debut)>100 && debut/10==0)
  {
   seq->setPourGC(debut);
   pourGC = seq->getPourGC();
  }
 }
 
 // initializing scoreMatrice tab and the GC percent at each position of the sequence
 for ( i = 0; i < nbMatrice; i++ ) {
  scoreMatrice[i] = 0;
  nbGC[i] = 0;
 }
 
  // nb of index tables necessary to go through
 if ( longeur < tmax ) {
  nbTabUtile = 0;
  while ( longeur > sm->getDecoupageCumul( nbTabUtile + 1 ) ) {
   nbTabUtile++;
  }
  nbTabUtile++;
 } else {
  nbTabUtile = nbTab;
 }
 
  // for each table compute the associated score
  //cout << "POS: " << debut << " nb tables used: " << nbTabUtile << endl;
  
  for ( int numTab = 0; numTab < nbTabUtile; numTab++ ) {
    m = debut + sm->getDecoupageCumul( numTab );
    n = sm->getDecoupage( numTab );
    o = m + n;
    if (o > tailleSeq) o=tailleSeq;
    p = ( int )( pow( ( float )4, sm->getDecoupage( numTab ) - 1 ) );
    // cpt = the word encoded
    cpt = 0;
    if ( debut == 0 )  {
      for ( j = m; j < o; j++ )   {
        cpt = ( cpt << 2 ) + seqCode[j];
      }
    }  else  {
      cpt = codeOld[numTab];
      cpt -= seqCode[m - 1] * p;
      cpt = cpt << 2;
      cpt += seqCode[o - 1];   
    }
   
    codeOld[numTab] = cpt;
    nbMatParcourirOld = nbMatParcourir;
    nbMatParcourir = matrices->getTabNbMatriceTailleSup( sm->getDecoupageCumul( numTab ) );
    // computes the actual number of matrices for which we have to compute the score,
    // it depends on the number of matrices of the table and on the number of matrices 
    // whose length do not exceed the length of the remaining of the sequence    
    //cout << "[returnIt] table=" << numTab << " nbMatParcourir=" << nbMatParcourir << " nbMatNonParcourir=" << nbMatNonParcourir;
    
    
    int firstNumMat = nbMatNonParcourir;
    int lastNumMat = nbMatParcourir-1;
    while (scoreMatrice[lastNumMat] < espMax[numTab][lastNumMat]) {
      scoreMatrice[lastNumMat] = -100000;
      lastNumMat--;
    }

    //cout << " last number of the matrix = " << lastNumMat << endl;
    
    if (lastNumMat >= firstNumMat) {
      accesMatCode = sm->getStructMatrice( numTab, cpt );
      for ( short mat = firstNumMat; mat <= lastNumMat; mat++ ) {
        accesMatCode2 = accesMatCode[mat];
        scoreMatrice[mat] += accesMatCode2[0];
        nbGC[mat] += accesMatCode2[1];
      }
    }
    
    /*
     
     CODE FROM AUDE : seems to have a bug with multiple tables
     
    switch(i) {
      case 0 :
        break;
        
      case 1 :
        //cout << "*** WARNING a ***" << endl;
        for (;nbMatParcourir>=nbMatNonParcourir; nbMatParcourir--) {
          if (scoreMatrice[nbMatParcourir-1] < espMax[i][nbMatParcourir-1]) {
            scoreMatrice[nbMatParcourir-1] = -100000;
          } else {
            break;
          }
        }
        break;
        
        default :
        //cout << "*** WARNING b ***" << endl;
        
        nbMatParcourir = min (nbMatParcourirOld, nbMatParcourir);
        for (;nbMatParcourir>=nbMatNonParcourir; nbMatParcourir--)    {
          if (scoreMatrice[nbMatParcourir-1] < espMax[i][nbMatParcourir-1])     {
            scoreMatrice[nbMatParcourir-1] = -100000;
          }     else     {
            break;
          }
        }
       break;
    }
    
   //cout << "  [returnIt] i=" << i << " nbMatParcourir=" << nbMatParcourir << " nbMatNonParcourir=" << nbMatNonParcourir << endl;

   if(nbMatParcourir != (nbMatNonParcourir+1)) // != 0)
// NON FAIT POUR UNE MATRICE
   // JSV: ajout != 0
   //if(nbMatNonParcourir == 0 || nbMatParcourir != (nbMatNonParcourir+1)) // != 0)
     // JSV
     //if(nbMatParcourir > 0)
   {
        cout << "*** WARNING 1 ***" << endl;
     
     // get the scores for all matrices of the i-th table for word cpt
     accesMatCode = sm->getStructMatrice( i, cpt );
     for ( short l = 0; l < nbMatParcourir; l++ )
     {
       accesMatCode2 = accesMatCode[l];
       scoreMatrice[l] += accesMatCode2[0];
       nbGC[l] += accesMatCode2[1];
     }
   }
     
     END CODE FROM AUDE
     
   */

    
   
 }



  // NON FAIT comprends pas pourquoi de nbMatNonParcourir
  for (int l=nbMatNonParcourir; l<nbMatrice; l++) {
    //  cout << "*** WARNING 2 ***" << endl;
    if (scoreMatrice[l]!=-100000) {
      scoreMatrice[l]-=fond[pourGC][taille[l]][nbGC[l]];
    }
  }

  /*  
    cout << "[scan] [";
    for (int m = 0; m < nbMatrice; m++) {
       cout << scoreMatrice[m] << " " << nbGC[m] << " " << fond[pourGC][taille[m]][nbGC[m]] << ", ";
    }
    cout << endl;
    cout << precision << endl;
  */

  return scoreMatrice;
}


// computes the occurrences of all matrices onto a sequence
// mini = length of the sequence - size of the longest matrix
void Metier2::lesHits()
{
  
  
   //cout << " **** ICI **** " << mini << " " << maxi << " " << tmin << " " << tmax << " " << matrices->getSeuil(nbMatrice-1) << endl;
  streambuf * f = cout.rdbuf();
  ofstream fs( ficRes.data(), ios_base::app );
  if ( fs.is_open()) cout.rdbuf(fs.rdbuf());
  cout << "Location\t\tMatrix\t\tScore"<<endl;
  // i = position in the sequence
  long i;
  // nbMatNonParcourir = matrices whose length is greater that the seq length - i
  nbMatNonParcourir=0;
  // we start by testing all the matrices for each position of the
  // sequence such that the position + the lenth of the matrix is less
  // than the length of the sequence
  for ( i = 0; i <mini ; i++ ) {

     //cout << "position=" << i << endl;

    // computes the score of all matrices at position i
     scoreMatrice = returnIt( i, tmax );
  
    
    //cout << "score=";
    //for ( int j = 0; j < nbMatrice; j++ ) cout << scoreMatrice[j] << " ";
    //cout << endl;
    
    
    for ( int j = 0; j < nbMatrice; j++ )  {
      //cout << scoreMatrice[j] << " " <<  matrices->getSeuil( j ) << endl;
      if ( scoreMatrice[j] >= matrices->getSeuil( j ))   {
         cout << i + 1 << "\t" << matrices->getMatrice(j)->getNom() << "\t" << matrices->getMatrice(j)->getSeuil() << "\t" << (double) scoreMatrice[j] <<endl;
      }
    }
  }
  
  //cout << "now until maxi " << endl;

  // then we test all only the matrices with length less than the
  // number of positions rmeaining in the sequence
  for ( ; i <maxi ; i++ ) {
    nbMatNonParcourir = matrices->getTabNbMatriceTailleSup(seq->getLength() - i);
    scoreMatrice = returnIt( i, seq->getLength() - i );
    
    /*
    cout << "score=";
    for ( int j = 0; j < nbMatrice; j++ ) cout << scoreMatrice[j] << " ";
e    cout << endl;
    */
    
    for ( int j = nbMatNonParcourir; j < nbMatrice; j++ ) {
      if ( scoreMatrice[j] >= matrices->getSeuil( j )) {
	 cout << i + 1 << "\t" << matrices->getMatrice(j)->getNom() << "\t" << matrices->getMatrice(j)->getSeuil() << "\t" << (double) scoreMatrice[j] <<endl;
      }
    }
  }
  
  cout.rdbuf(f);
  
}





void Metier2::calcFond()
{
 fond = new long ** [9];
 for(int i=0; i<9; i++)
 {
  float f = 0.05*(i+6);
  fond[i] = new long * [(tmax+1)];
  for(int j = 0; j<tmax+1 ; j++)
  {
   fond[i][j] = new long[(j+1)];
   for (int k=0; k<j+1; k++)
   {
    fond[i][j][k]=k*(int)roundl((log(f/2)*precision))+(j-k)*(int)roundl(log((1-f)/2)*precision);
   }
  }
 }
}


//int Metier2::it( Matrice * mat, unsigned long debut)
//{
// int s = 0, nbGC=0, c;
// for ( int j = 0; j < mat->getTaille(); j++ )
// {
//  c = seqCode[debut + j];
//  s += mat->getMatDistInt(c , j );
//  if (c==1||c==2) nbGC++;
// }
// s -= fond[pourGC][mat->getTaille()][nbGC];
// return s;
// 
//}
