#include "StructMatrice.h"
#include <algorithm>

StructMatrice::StructMatrice( Matrices* m , unsigned long mo)
{
  matrices = m;
  nbTab = 1;
  if (matrices->getTailleMaxMatrice()>10) nbTab = 2;
  if (matrices->getTailleMaxMatrice()>20) nbTab = 3;
  if (matrices->getTailleMaxMatrice()>30) nbTab = 4;
  //cout << matrices->getTailleMaxMatrice() << endl;
  // if (matrices->getTailleMaxMatrice()>32) nbTab = 5;
  nbCaseMax = ( mo * ( unsigned long ) pow( ( float )2, 20 ) ) / sizeof( int );
  
  
  
  structMatrices = new tab*[nbTab];
  decoupage = new int[nbTab];
  decoupageCumul = new int[nbTab + 1];
  taille = new unsigned long[nbTab];
  decoupage2 = new int[nbTab];
  taille2 = new unsigned long[nbTab];
  
  calcTranches();
  rechercheCombin();
  nbMatriceStruct = 0;
  for ( int i = 0; i < matrices->getNbMatrice(); i++ )
  {
    addMatrice( i );
  }
}

int StructMatrice::getNbMatriceStruct()
{
  return nbMatriceStruct;
}

int StructMatrice::getDecoupageCumul(int i)
{
  return decoupageCumul[i];
}

int StructMatrice::getNbTab()
{
  return nbTab;
}
int StructMatrice::getDecoupage(int i)
{
  return decoupage[i];
}

int ** StructMatrice::getStructMatrice( int i, unsigned long j )
{
  if(j>=taille[i]){cerr << "alerte " << taille[i] << " " << j << endl;exit(-1);}
  return structMatrices[i] [j];
}

void StructMatrice::addMatrice( int i )
{
  int nbTabUtile = 0;
  int t = matrices->getMatrice(i)->getTaille();
  while ( t > 0 && nbTabUtile < nbTab )
  {
    t -= decoupage[nbTabUtile];
    nbTabUtile++;
  }
  for ( int j = 0; j < nbTabUtile; j++ )
  {
    addMatriceDecoupage( i, j, nbTabUtile );
  }
  nbMatriceStruct++;
}


void StructMatrice::addMatriceDecoupage( int j, int partie, int nbTabUtile )
{
  int t = 0;
  unsigned long s = 0, s2;
  int score = 0, score2, nbGC=0, nbGC2;
  typedef stack < Couple > pC;
  pC * pile = new pC;
  bool vide = false;
  int jusque, i;
  if ( ( partie == nbTabUtile - 1 ) && ( ( matrices->getMatrice(j)->getTaille() - decoupageCumul[partie] ) != taille[j] ) )
    jusque = ( matrices->getMatrice(j)->getTaille() ) - decoupageCumul[partie];
  else
    jusque = decoupage[partie];
  while ( !vide )
  {
    while ( t < decoupage[partie] - 1 )
    {
      t++;
      for ( i = 1; i < 4; i++ )
      {
        s2 = ( s << 2 ) + i;
        score2 = score;
        nbGC2=nbGC;
        if ( t <= jusque )
        {
          score2 += matrices->getMatrice(j)->getMatDistInt( i, ( t - 1 + decoupageCumul[partie] ) );
          if (i==1||i==2) nbGC2+=1;
        }
        Couple c2( s2, score2, nbGC2, t );
        pile->push( c2 );
      }
      s = s << 2;
      if ( t <= jusque )
      {
        score += matrices->getMatrice(j)->getMatDistInt( 0, ( t - 1 + decoupageCumul[partie] ) );
      }
    }
    t++;
    for ( i = 0; i < 4; i++ )
    {
      s2 = ( s << 2 ) + i;
      score2 = score;
      nbGC2=nbGC;
      if ( t <= jusque )
      {
        score2 += matrices->getMatrice(j)->getMatDistInt( i, ( t - 1 + decoupageCumul[partie] ) );
        if (i==1||i==2) nbGC2+=1;
      }
      structMatrices[partie] [s2] [j][0] = score2;
      structMatrices[partie] [s2] [j][1] = nbGC2;
    }
    if ( !pile->empty() )
    {
      Couple c = pile->top();
      pile->pop();
      t = c.getTaille();
      s = c.getMotif();
      score = c.getScore();
      nbGC = c.getNbGC();
    }
    else
      vide = true;
  }
  delete pile;
}


void StructMatrice::rechercheCombin()
{
  Decoupage d = calcDecouage(nbTab, matrices->getTailleMaxMatrice(), nbCaseMax);
  while  ( d.getNbAcces()==9999 && nbTab<8)
  {
  //d.toString();
    nbTab++;
    structMatrices = new tab*[nbTab];
  decoupage = new int[nbTab];
  decoupageCumul = new int[nbTab + 1];
  taille = new unsigned long[nbTab];
  decoupage2 = new int[nbTab];
  taille2 = new unsigned long[nbTab];
    d = calcDecouage(nbTab, matrices->getTailleMaxMatrice(), nbCaseMax);
  }
  if  ( d.getNbAcces()==9999 )
  {
    cerr << "Matrices are too long or you do not give enough memory" << endl;
    exit( -1 );
  }

  d.addPos(matrices->getTailleMaxMatrice(), 0);
  d.toString();
  for ( int i = 0; i < nbTab; i++ )
  {
    decoupage[i] = d.getPos(i) - d.getPos(i-1);
  }
  int som = 0;
  for ( int j = 0; j < nbTab; j++ )
  {
    taille[j] = ( unsigned long ) pow( ( float )4, decoupage[j] );
    decoupageCumul[j] = som;
    
    try{
    constTab( j, matrices->getTabNbMatriceTailleSup()[decoupageCumul[j]], taille[j] );
    }
    catch (exception e) {
    cerr << "Limitation memory of your system or your compiler" << endl;
    exit( -1 );
	   }
    
    
    som += decoupage[j];
  }
  decoupageCumul[nbTab] = matrices->getTailleMaxMatrice();
}


void StructMatrice::constTab( int j, int nbMat, int t )
{
  structMatrices[j] = new int ** [t];
  for ( unsigned long i = 0; i < t; i++ )
  {
    structMatrices[j] [i] = new int*[nbMat];
    for ( unsigned long k = 0; k < nbMat; k++ )
    {
      structMatrices[j] [i][k] = new int[2];
    }
  }
}

double StructMatrice::calcNbAcess(int a)
{
  double nbAcces = 0;
  for (int i = 0; i<matrices->getNbMatrice(); i++)
  {
    nbAcces += 1-matrices->getMatrice(i)->getPoids(a-1);
  }
  return nbAcces;
}

unsigned long StructMatrice::calcNbCase(int a, int b)
{
  if (b-a == 0) return 0;
  return (matrices->getTabNbMatriceTailleSup(a) * ( unsigned long ) pow( ( float )4, (b-a)))*2;
}

void StructMatrice::calcTranches()
{
  int tMax = matrices->getTailleMaxMatrice();
  nbAcess = new double [tMax+1];
  for (int i = 0; i<tMax+1; i++)
  {
    nbAcess[i]= calcNbAcess(i);
  }
  nbCase = new long * [tMax+1];
  for (int i = 0; i<tMax+1; i++)
  {
    nbCase[i]=new long[min(11, tMax-i+1)];
  }
  for (int i = 0; i<tMax+1; i++)
  {
    for (int j = 0; j<min(11, tMax-i+1); j++)
    {
      nbCase[i][j]=calcNbCase(i, i+j);
    }
  }
}

Decoupage  StructMatrice::calcDecouage(int nbTab, int k, long nbC)
{
  if (nbC < 0 || k<2*nbTab)
  {
    return Decoupage(9999);
  }
  if(nbTab==1)
  {
    if((k<11) && ((nbC-nbCase[0][k]) >= 0))
    {
    Decoupage d(nbAcess[0]);
     d.setMo(((nbCaseMax-(nbC-nbCase[0][k]))*sizeof( int ))/ ( unsigned long ) pow( ( float )2, 20 ));
      return d ; 
    }
    else
    {
      return Decoupage(9999);
    }
  }
  int deb = max(nbTab-1, k-10);
  long double tb[k-deb];
  for (int i=deb; i<k; i++)
  {
    tb[i-deb]=calcDecouage(nbTab-1, i, (nbC - nbCase[i][k-i])).getNbAcces();
    if (tb[i-deb]!=9999)
    {
      tb[i-deb]+=nbAcess[i];
    }
  }
  long double * ad = min_element(tb, tb+k-deb);
  if (*ad == 9999) return Decoupage(9999);
  int pos = ad-tb+deb;
  //cout << *ad << " " << nbC - nbCase[pos][k-pos] << endl;
  Decoupage d = calcDecouage(nbTab-1, pos, (nbC - nbCase[pos][k-pos]));
  d.addPos(pos, nbAcess[pos]);
  return d;
}



