/**
 * La classe VectorNodes
 * @author Guillermo
 */

#include "VectorNodes.h"

using namespace std;

VectorNodes::VectorNodes(void)
{
}

VectorNodes::VectorNodes(int nElementos)
{
        nodes = new vector<NodeBinary *>(nElementos);
        to_make_clusters = new vector<NodeBinary *>(nElementos);
}



int VectorNodes::generate_vector(int nElementos)
{
        NodeBinary * ptrNode[nElementos];
        for(int i=0;i<nElementos;i++)
                *(nodes->begin()+i)=*(to_make_clusters->begin()+i)=new NodeBinary(i);
}


int VectorNodes::generate_branch(int coordx,int coordy,int node_info)
{
        int uniteIn;
        int erase;
        int *aux;
        int position=0;
        int num;
        NodeBinary * ptr;
        if(coordx<coordy)
        {
                uniteIn=coordx;
                erase=coordy;
        }
        else
        {
                uniteIn=coordy;
                erase=coordx;
        }
        ptr=new NodeBinary (node_info);
        ptr->set_sonL((nodes->at(uniteIn)));
        ptr->set_sonR((nodes->at(erase)));
        ptr->set_height(ptr->get_height());
        (nodes->at(uniteIn))=ptr;
        nodes->erase(nodes->begin()+erase);
        num=ptr->get_sonL()->get_numClusters()+ptr->get_sonR()->get_numClusters();
        aux = new int[num];
        for(int i=0;i<ptr->get_sonL()->get_numClusters();i++)
        {
                aux[position]=ptr->get_sonL()->get_vectorClusters(i);
                position ++;
        }
        for(int i=0;i<ptr->get_sonR()->get_numClusters();i++)
        {
                aux[position]=ptr->get_sonR()->get_vectorClusters(i);
                position ++;
        }
        ptr->add_to_vectorClusters(aux,num);
}


int VectorNodes::heightOfTree()
{
        NodeBinary *ptr;
        ptr=(nodes->at(0));
        return ptr->get_height();
}

vector<Cluster2> VectorNodes::print_cluster(int hot,int dimension,float **constant, float p1, Matrices *mats)
{
        int height=1;
        int count=0;
        int salir=0;
        vector<int> vec;
        Selection s;
        vector<Cluster2> vClusters;
        Cluster2 c;
        do
        {
        for (int i=0;i<dimension;i++)
        {
                if((to_make_clusters->at(i))->get_info()!=-1)
                {
                        NodeBinary *ptr=(to_make_clusters->at(i))->get_father();

                        if (ptr->get_height()==height)
                        {
                                if(ptr->get_sonL()->get_isCluster())
                                {
                                        if(ptr->get_sonR()->get_isCluster())
                                        {

                                                vec=ptr_to_list(ptr);
                                                if(s.Aude(vec,constant,p1, mats))
                                                {
                                                        (to_make_clusters->at(ptr->get_sonR()->get_info()))->set_info(-1);
                                                        (to_make_clusters->at(i))=ptr;
                                                        if(ptr->get_height()==hot)
                                                        {
                                                                ptr->get_vectorClusters();
                                                                Cluster2 c0;
                                                                add_to_cluster2(c0,ptr);
                                                                vClusters.push_back(c0);
                                                        }
                                                }
                                                else
                                                {
                                                        ptr->set_isCluster(false);
                                                        set_fathers_to_false(ptr);
                                                        ptr->get_sonL()->get_vectorClusters();
                                                        ptr->get_sonR()->get_vectorClusters();
                                                        Cluster2 c1;
                                                        Cluster2 c2;
                                                        add_to_cluster2(c1,ptr->get_sonL());
                                                        vClusters.push_back(c1);
                                                        add_to_cluster2(c2,ptr->get_sonR());
                                                        vClusters.push_back(c2);
                                                        (to_make_clusters->at(i))->set_info(-1);
                                                        (to_make_clusters->at(ptr->get_sonR()->get_info()))->set_info(-1);
                                                }
                                        }
                                        else
                                        {
                                                ptr->set_isCluster(false);
                                                set_fathers_to_false(ptr);
                                                this->print_node(to_make_clusters->at(i));
                                                Cluster2 c3;
                                                add_to_cluster2(c3,ptr->get_sonL());
                                                vClusters.push_back(c3);
                                                (to_make_clusters->at(i))->set_info(-1);
                                        }
                                }
                                else
                                {
                                        ptr->set_isCluster(false);
                                        set_fathers_to_false(ptr);
                                        this->print_node(to_make_clusters->at(i));
                                        Cluster2 c4;
                                        add_to_cluster2(c4,ptr->get_sonR());
                                        vClusters.push_back(c4);
                                        (to_make_clusters->at(i))->set_info(-1);
                                }
                        }

                }
                else
                {
                        salir++;
                        if (salir==dimension)
                        {
                                //cout <<"SALE POR LOS -1!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! "<<endl;
                                return vClusters;
                        }
                }
        }
        height++;
        salir=0;
        }while(height!=hot+1);
        return vClusters;
}

void VectorNodes::add_to_cluster2(Cluster2 &cl,NodeBinary *ptr)
{
        for(int i=0;i<ptr->get_numClusters();i++)
                cl.addMat(ptr->get_vectorClusters(i));
}

vector<int> VectorNodes::ptr_to_list(NodeBinary * ptr)
{
        vector<int> v;
        for (int i=0;i<ptr->get_numClusters();i++)
                v.push_back(ptr->get_vectorClusters(i));
        return v;
}

/*void VectorNodes::print_node(int numNodo)
{
        int num2= (to_make_clusters->at(numNodo))->get_numClusters();
}*/

void VectorNodes::print_node(NodeBinary *ptr)
{
        ptr->get_vectorClusters();
}

void VectorNodes::set_fathers_to_false(NodeBinary *ptr)
{
        while(ptr->get_father()!=NULL)
        {
                ptr->get_father()->set_isCluster(false);
                ptr=ptr->get_father();
        }
}


